routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

//Route::get('/', function () {
//    return view('welcome');
//});
Route::group(['prefix'=>'admin', 'namespace'=>'Admin' ],function(){
    // login admin
    Route::get('login','LoginController@showLoginForm')->name('login_admin');
    Route::post('login','LoginController@login')->name('login_admin');
    Route::get('logout', 'LoginController@logOut')->name('logout');
});
Route::group(['prefix'=>'admin','namespace'=>'Admin','middleware' => ['admin']],function(){
    Route::get('/', 'AdminController@home')->name('admin_home');
    // product category
    Route::get('get-child-cate', 'ProductController@getChildCategory')->name('get_child_cate');
    Route::get('create-product', 'ProductController@createProduct')->name('create_product');
    Route::resource('category','CategoryController');
    Route::resource('product','ProductController');
    // create user
    Route::get('create-user','UserController@showCreateUser')->name('create_user');
    Route::post('create-user','UserController@createUser')->name('add_user');
    // orders
    Route::resource('order','OrderController');
    Route::get('list-order','OrderController@anyDatatable')->name('dt_order');
    Route::get('update-status-order','OrderController@updateStatus')->name('update_status_order');
    Route::get('list-items/{id}','OrderController@anyDatatableOrderItem')->name('dt_order_item');
//    Route::get('detail-order','OrderController@detailOrder')->name('dt_order');



});

Route::group(['namespace'=>'Site' ],function(){
    // login site
    Route::get('login-customer','LoginController@showLoginForm')->name('login_customer');
    Route::post('login-customer','LoginController@login')->name('login_customer');
    Route::get('logout', 'LoginController@logOut')->name('logout');
});
Route::group(['namespace'=>'Site'],function(){
    Route::get('/', 'HomeController@index')->name('site_home');
    Route::get('/register-customer', 'CustomerController@register')->name('register');
    Route::resource('customer', 'CustomerController');
    //product ajax
    Route::get('/detail-product', 'ProductController@getDetaiProduct')->name('detail_product');
    Route::post('/addcart-product', 'ProductController@addToCart')->name('add_to_cart');
    //product
    Route::get('product/{slug}', 'ProductController@getDetailProduct')->name('get_detail_product');
    Route::get('category/{slug}', 'ProductController@getProductsCategory')->name('get_category_product');
    Route::post('product/review', 'ProductController@addReview')->name('add_review');

    // cart
    Route::get('/my-cart', 'OrderController@showCart')->name('my_cart');
    Route::get('/remove-item-cart', 'ProductController@removeItemCart')->name('remove_item_cart');
    Route::get('/update-item-cart', 'ProductController@updateItemCart')->name('update_item_cart');
    Route::get('/get-total-price', 'ProductController@getTotalPrice')->name('get_total_price');
    // checkout
    Route::get('/check-out', 'OrderController@showPayMent')->name('check_out');
    Route::post('/check-out', 'OrderController@createOrder')->name('create_order');
    Route::get('/update-cart', 'OrderController@updateCartHeader')->name('update_cart');

});
Auth::routes();

//Route::get('/home', 'HomeController@index')->name('home');

app/Http/Controllers/Site/CustomerController.php
<?php

namespace App\Http\Controllers\Site;

use App\Entity\Customer;
use App\Entity\User;
use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Ultility\Ultility;
use Illuminate\Support\Facades\Auth;
use Yajra\Datatables\Datatables;
use Illuminate\Support\Facades\DB;
use Illuminate\Database\Eloquent\Builder;
use Validator;
class CustomerController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
    }
    public function register(){
        return view('site.register.register');
    }
    public function createUser(Request $request){

    }


    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $validator = $this->validateRegister($request);
        if ($validator->fails()) {
            return back()->withErrors($validator)->withInput();
        }
        $userId =  $this->insertUser($request);
        $this->insertCustomer($request,$userId);
        return redirect()->back()->with('status', 'Đăng ký thành công');

    }
    private function validateRegister(Request $request){
        $messages = [
            "email.required" => "Email is required",
            "email.email" => "Email is not valid",
            "email.unique" => "Email registered. Pls Choose other email",
            "customer_name.required" => "Name is required",
            "nick_name.required" => "Nick name is required",
            "address.required" => "Phone is required",
            "password.required" => "Password is required",
            "password.min" => "Password must be at least 6 characters"
        ];
        return $validator = Validator::make($request->all(), [
            'email' => 'required|unique:users',
            'password' => 'required|min:6',
            'customer_name' => 'required',
            'address' => 'required',
            'nick_name' => 'required'
        ], $messages);

    }
    private function insertUser(Request $request){
        $userId =  User::insertGetId([
            "email"=>$request->input('email'),
            "password"=>bcrypt($request->input('password')),
            "name"=>$request->input('customer_name'),
            "role"=>1,
            "created_at"=> new \DateTime(),
            "updated_at"=> new \DateTime(),
        ]);
        return $userId;
    }
    private function insertCustomer(Request $request, $userId){
        Customer::insert([
           "customer_name"=>$request->input('customer_name'),
           "customer_user_id"=>$userId,
           "email"=>$request->input('email'),
           "nick_name"=>$request->input('nick_name'),
           "address"=>$request->input('address'),
            "created_at"=> new \DateTime(),
            "updated_at"=> new \DateTime(),
        ]);
    }
    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

app/Http/Controllers/Site/HomeController.php
<?php

namespace App\Http\Controllers\Site;

use App\Entity\OrderItem;
use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Entity\Category;
use App\Entity\CategoryPost;
use App\Entity\Product;
use App\Entity\Post;
use App\Ultility\Ultility;
use Illuminate\Support\Facades\DB;

use Validator;
class HomeController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $productId= array();
        $productBestSaleID = OrderItem::select(array('product_id', DB::raw('COUNT(order_item.product_id) as total')))
                    ->groupBy('product_id')->orderBy('total','desc')->limit(6)->get();
        if($productBestSaleID->count() > 0){
            foreach ($productBestSaleID as $product){
                $productId[]=$product->product_id;
            }
        }
        $productBestSale = Product::leftJoin('posts','products.post_id','posts.post_id')
            ->leftJoin('category_post','posts.post_id','category_post.post_id')
            ->join('categories','categories.category_id','category_post.category_id')
            ->select(
                'products.product_id',
                'products.code',
                'products.price',
                'posts.title',
                'posts.slug',
                'posts.description',
                'posts.image',
                'categories.title as category'
            )
            ->whereIn('products.product_id',$productId)
            ->orderBy('products.product_id','desc')->get();

        $productDiscount = Product::leftJoin('posts','products.post_id','posts.post_id')
            ->leftJoin('category_post','posts.post_id','category_post.post_id')
            ->join('categories','categories.category_id','category_post.category_id')
            ->select(
                'products.product_id',
                'products.discount',
                'products.code',
                'products.price',
                'posts.title',
                'posts.slug',
                'posts.description',
                'posts.image',
                'categories.title as category'
            )
            ->where('discount','>',0)
            ->orderBy('products.product_id','desc')->get();

        $productCombo = Product::leftJoin('posts','products.post_id','posts.post_id')
            ->leftJoin('category_post','posts.post_id','category_post.post_id')
            ->join('categories','categories.category_id','category_post.category_id')
            ->select(
                'products.product_id',
                'products.discount',
                'products.code',
                'products.price',
                'posts.title',
                'posts.slug',
                'posts.description',
                'posts.image',
                'categories.title as category'
            )
            ->where('category_post.category_id',9)
            ->orderBy('products.product_id','desc')->get();
        return view('site.home.index',compact('productBestSale','productDiscount','productCombo','productId'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {

    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

app/Http/Controllers/Site/LoginController.php
<?php

namespace App\Http\Controllers\Site;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Entity\User;
use App\Ultility\Ultility;
use Illuminate\Support\Facades\Auth;
use Validator;
class LoginController extends Controller
{
    public function showLoginForm(){
        return view('site.login.login');
    }
    public function login(Request $request){
        $messages = [
            "email.required" => "Email is required",
            "email.email" => "Email is not valid",
            "password.required" => "Password is required",
        ];

        $validator = Validator::make($request->all(), [
            'email' => 'required|email',
            'password' => 'required'
        ], $messages);
        if ($validator->fails()) {
            return back()->withErrors($validator)->withInput();
        }
        $data = [
            'email' => $request->input('email'),
            'password' => $request->input('password'),
        ];

        if (Auth::attempt($data)) {
            return redirect()->route('site_home');
        } else {
            return redirect()->back()->with('status', 'Email hoặc Password không chính xác');
        }
    }
    public function logOut(){
        Auth::logout();
        return redirect()->route('login_customer');
    }
}

resources/views/site/register/register.blade.php
@extends('site.layout.site')

@section('title', 'register')
@section('content')
    <ul class="breadcrumb">
        <li><a href="index.html"><i class="fa fa-home"></i></a></li>
        <li><a href="#">Account</a></li>
        <li><a href="register.html">Register</a></li>
    </ul>
    <div class="row">
        <div class="col-sm-3 hidden-xs column-left" id="column-left">
            <div class="column-block">
                <div class="columnblock-title">Account</div>
                <div class="account-block">
                    <div class="list-group"> <a class="list-group-item" href="login.html">Login</a> <a class="list-group-item" href="register.html">Register</a> <a class="list-group-item" href="forgetpassword.html">Forgotten Password</a> <a class="list-group-item" href="#">My Account</a> <a class="list-group-item" href="#">Address Book</a> <a class="list-group-item" href="#">Wish List</a> <a class="list-group-item" href="#">Order History</a> <a class="list-group-item" href="download">Downloads</a> <a class="list-group-item" href="#">Reward Points</a> <a class="list-group-item" href="#">Returns</a> <a class="list-group-item" href="#">Transactions</a> <a class="list-group-item" href="#">Newsletter</a><a class="list-group-item last" href="#">Recurring payments</a> </div>
                </div>
            </div>
        </div>
        <div class="col-sm-9" id="content">
            <h1>Đăng ký tài khoản</h1>
            <p>If you already have an account with us, please login at the <a href="login">login page</a>.</p>
            @if (session('status'))
                <ul>
                    <li class="text-danger"> {{ session('status') }}</li>
                </ul>
            @endif
            <form class="form-horizontal" enctype="multipart/form-data" method="post" action="{{route('customer.store')}}">
                {!! csrf_field() !!}
                {{ method_field('POST') }}
                <fieldset id="account">
                    <legend>Nhập thông tin đăng ký</legend>
                    <div style="display: none;" class="form-group required">
                        <label class="col-sm-2 control-label">Customer Group</label>
                        <div class="col-sm-10">
                            <div class="radio">
                                <label>
                                    <input type="radio" checked="checked" value="1" name="customer_group_id">
                                    Default</label>
                            </div>
                        </div>
                    </div>
                    <div class="form-group required">
                        <label for="input-firstname" class="col-sm-2 control-label">Họ tên</label>
                        <div class="col-sm-10">
                            <input type="text" class="form-control" id="input-firstname" placeholder="Họ tên" value="" name="customer_name">
                        </div>
                    </div>
                    @if ($errors->has('customer_name'))
                        <span class="help-block">
                                         <strong>{{ $errors->first('customer_name') }}</strong>
                                        </span>
                    @endif
                    <div class="form-group required">
                        <label for="input-fax" class="col-sm-2 control-label">Địa chỉ</label>
                        <div class="col-sm-10">
                            <input type="text" class="form-control" id="input-fax" placeholder="Địa chỉ" value="" name="address">
                        </div>
                    </div>
                    @if ($errors->has('address'))
                        <span class="help-block">
                                         <strong>{{ $errors->first('address') }}</strong>
                                        </span>
                    @endif
                    <div class="form-group required">
                        <label for="input-lastname" class="col-sm-2 control-label">Nick Name</label>
                        <div class="col-sm-10">
                            <input type="text" class="form-control" id="input-lastname" placeholder="Nick name" value="" name="nick_name">
                        </div>
                    </div>
                    @if ($errors->has('nick_name'))
                        <span class="help-block">
                                         <strong>{{ $errors->first('nick_name') }}</strong>
                                        </span>
                    @endif
                    <div class="form-group required">
                        <label for="input-email" class="col-sm-2 control-label">Email</label>
                        <div class="col-sm-10">
                            <input type="email" class="form-control" id="input-email" placeholder="E-Mail" value="" name="email">
                        </div>
                    </div>
                    @if ($errors->has('email'))
                        <span class="help-block">
                                         <strong>{{ $errors->first('email') }}</strong>
                                        </span>
                    @endif
                    <div class="form-group required">
                        <label for="input-password" class="col-sm-2 control-label">Mật khẩu</label>
                        <div class="col-sm-10">
                            <input type="password" class="form-control" id="input-password" placeholder="Password" value="" name="password">
                        </div>
                    </div>
                    @if ($errors->has('password'))
                        <span class="help-block">
                                         <strong>{{ $errors->first('password') }}</strong>
                                        </span>
                    @endif

                </fieldset>

                <div class="buttons">
                    <div class="pull-right">I have read and agree to the <a class="agree" href="#"><b>Privacy Policy</b></a>
                        <input type="checkbox" value="1" name="agree">
                        &nbsp;
                        <input type="submit" class="btn btn-primary" value="Continue">
                    </div>
                </div>
            </form>
        </div>
    </div>
@endsection